clear, clc, mode(0), close(winsid()) 
/// Offline odhad regresního modelu $y_t=b_0u_t+a_1y_{t-1}+k+e_t$

///Porovnání s online odhadem

load data5.sod;
nd=size(y,2);   


///////////////Online odhad 
nps=3+1;    //dimenze informační matice V
V=zeros(nps,nps);    //počáteční informační matice V
k=0;                 //počáteční počítadlo k

for t=2:nd
    Ps=[y(t) u(t) y(t-1)  1];//rozšířený regresní vektor
    V=V+Ps'*Ps;        //update statistiky V 
    k=k+1;             //update statistiky k 
end
//rozklad informační matice V
Vy=V(1,1);        // část Vy 
Vyps=V(2:$,1);   // část Vyps
Vps=V(2:$,2:$);  //část Vps

//bodové odhady
theta_online=inv(Vps)*Vyps;      //bodové odhady regresních koeficientů
r_online=(Vy-Vyps'*inv(Vps)*Vyps)/k; //bodový odhad rozptylu







/////////////// Offline odhad
t=2:nd;                       // počet dat
Y=y(t)';                      // vektor výstupů
X=[u(t)' y(t-1)'  ones(99,1)];   //matice regresních vektorů
theta_offline=inv(X'*X)*X'*Y;           // bodové odhady regresních koeficientů
r_offline=Y'*(Y-X*theta_offline)/nd;      //bodový odhad rozptylu

////výsledky
disp('Porovnání odhadů regresních koeficientů',[theta_online theta_offline])
disp('Porovnání odhadů rozptylu',[r_online r_offline])







